using System;
using System.Data;
using Oracle.DataAccess.Client;
using System.Windows.Forms;

namespace TGradebook_In_C_Sharp
{
	/// <summary>
	/// The class will provide connection to database, and other
	/// operations to performed on the database.
	/// </summary>
	public class TGradebookDB 
	{
        #region Data Members of TGradebookDB 
        static string connString = null;
        static OracleConnection cnn = null;
        static private OracleDataReader reader = null;
		static private OracleCommand cmd = null;
		static private System.Data.DataSet dsGradesAndPolicy = null;
		static private System.Data.DataTable tb = null;
        static private OracleDataAdapter adapter;
        static private string sqlPolicy = null;
        static private string sqlVGrades = null;
        static private string sqlVClassReport = null;
        #endregion
	
		#region Login and Database Connection
     
        public TGradebookDB() {
            //connString = "Data Source=(DESCRIPTION=" + "(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST=Delphi.cs.csubak.edu)(PORT=1521)))" + "(CONNECT_DATA=(SERVER=DEDICATED)(SERVICE_NAME=ORCL)));" + "User Id=TGradebook;Password=c3m4p2s;";
            connString = "DATA SOURCE=DELPHIDB;USER ID=TGRADEBOOK;Password=c3m4p2s;";
            sqlVClassReport = "SELECT * FROM VClassReport WHERE CID = ";
            sqlPolicy = "SELECT CID, NUMHWK, MAXHWK, PCTHWK, HWKDROPS, MAXMIDTERM1, PCTMIDTERM1, " +
                         " MAXMIDTERM2, PCTMIDTERM2, MAXFINAL, PCTFINAL FROM Policy WHERE CID = ";
        }
        
		static public void openConnection() 
		{
            if ( cnn == null ) cnn = new OracleConnection(connString);

            if ( cnn.State == System.Data.ConnectionState.Closed) cnn.Open();
		}
		public static bool login( string user, string passwd ) 
		{
			try 
			{
				openConnection();
				cmd = cnn.CreateCommand();
				cmd.CommandText = (
					"select * from instructors where Name = '" + 
					user + "' AND Password = '" + passwd + "'" );
				// Console.WriteLine( cmd.CommandText );
				cmd.CommandType = System.Data.CommandType.Text;
				reader = cmd.ExecuteReader (CommandBehavior.CloseConnection);
				if ( reader.HasRows ) 
				{
					if ( reader.Read() ) 
					{
						GlobalConstsVars.IID = (int) reader.GetDecimal(0);
						GlobalConstsVars.IName = reader.GetString(1);
						GlobalConstsVars.FTPString = reader.GetString(3);
					}
					GlobalConstsVars.IName = user;
					return true;
				} 
				else return false;
			}  
			catch (System.Exception e) 
			{ 
				Console.WriteLine(e.StackTrace );
				return false;
			}
			finally 
			{
				if ( reader != null) reader.Close();
				if ( cmd != null )  cmd.Dispose();
				if ( cnn != null ) cnn.Close();
			}
		} // End of "login( string, string)"
	#endregion

		#region H. Wang - Fill in the course related the combo boxes.

        static void fillComboByQuery(string sql, System.Windows.Forms.ComboBox cmb)
        {
            try
            {
                openConnection();
                cmd = new OracleCommand(sql, cnn);
                reader = cmd.ExecuteReader(System.Data.CommandBehavior.CloseConnection);
                while (reader.HasRows && reader.Read())
                {
                    cmb.Items.Add(reader.GetValue(0));
                }
            }
            catch (System.Exception e) { Console.WriteLine(e.StackTrace); }
            finally
            {
                reader.Close();
                cmd.Dispose();
                cnn.Close();
            }
        }
       
		public static  void fillYears( System.Windows.Forms.ComboBox cmb) 
		{
			string strGetYear = "select unique year  from classes" +
							" where IID = " + GlobalConstsVars.IID + " order by year desc";
            fillComboByQuery(strGetYear, cmb);
        }

        public static void fillMajors(System.Windows.Forms.ComboBox cmb)
        {
            string strGetYear = "select * from vMajors order by MajorList";
            fillComboByQuery(strGetYear, cmb);
            //cmb.SelectedIndex = 1;
        }

		public static  void fillCourseNamesByYearQuarter(string year, string quarter, ComboBox cmb) 
		{
            cmb.Items.Clear();
            string sql = "select distinct CName from classes " +   "where year = " + year + " and quarter = '" +
                    quarter + "' and IID = " + GlobalConstsVars.IID + " order by CName";
            fillComboByQuery(sql, cmb);
   		}
        
		#endregion

		#region H. Wang - Retrieve class, policy, grades and students information.

		public static string getAllGrades( string StudentID ) 
		{
			try 
			{
				string sqlAllGrades = "select * from VAllGrades where SID = " + StudentID + 
									  " AND IID = " + GlobalConstsVars.IID + " order by cname";
				string result = null;
				openConnection();
				cmd = new OracleCommand(sqlAllGrades, cnn);
				reader = cmd.ExecuteReader(CommandBehavior.CloseConnection );
				int k = 1;
				while ( reader.HasRows && reader.Read() ) 
				{
					result += (k + "." ).PadLeft(8) + "  " +
						// (reader.GetString(1) + ", " + reader.GetString(2).PadRight(20) +
						reader.GetString(4).PadRight(10) + 
						reader.GetString(3).PadRight(5) +
						reader.GetString(5) + 
						 "\n";
					k++;
				}
				return result;
			} 
			catch(System.Exception e) { Console.WriteLine (e.StackTrace ); return ""; }
			finally { reader.Close(); cmd.Dispose(); cnn.Close() ; } 
		}
		public static void setGlobleCIDbyYQNS( ) 
		{
			string sqlClass = "SELECT * FROM CLASSES WHERE" +
				" Year = " + GlobalConstsVars.cYear + " and " + 
				" Quarter = '" + GlobalConstsVars.cQuarter  + "' and" + 
				" cName = '" + GlobalConstsVars.cName + "' and" + 
				" Section = " + GlobalConstsVars.cSection ;
			try 
			{
				GlobalConstsVars.CID = -1;  // In case no class is selected
				openConnection();
				cmd = new OracleCommand(sqlClass, cnn);
				reader = cmd.ExecuteReader(System.Data.CommandBehavior.CloseConnection);
				if ( reader.HasRows && reader.Read() ) 
				{
					GlobalConstsVars.CID = (int) reader.GetDecimal(0);
				}
                return ;
			} 
			catch (System.Exception e) { Console.WriteLine (e.StackTrace); }
			finally 
			{
				reader.Close();
				cmd.Dispose();
				cnn.Close();
			}
		}

		static string buildGradeSQLString (int classID, int cntHWK ) 
		{
			string tmp = "SELECT CID, SID, LastName, FirstName, Ranking, Total, Grade";
			for ( int i = 1; i <= cntHWK ; i ++ ) tmp += ", HW" + i;
			tmp += ", MIDTERM1, MIDTERM2, Final,  Comments FROM VGrades WHERE CID = " + classID +
                " ORDER BY FirstName, LastName" ;
			return  tmp; //"select * from vgrades where cid = " + classID;
		}

        static void fillTableAndAddToDataSet(string sql, string tableName, System.Data.DataSet ds)
        {
            adapter = new OracleDataAdapter(sql, cnn); // Use a select SQL statement to create a adapter 
            tb = new System.Data.DataTable(tableName); // Create a table based on a given table name
            adapter.Fill(tb);                           // Fill the able with records
            ds.Tables.Add(tb);                          // Add the table to dataset.
            adapter.Dispose();
            tb = null;
            adapter.Dispose();
        }

        public static System.Data.DataSet getGradesAndPolicy() 
		{
 			dsGradesAndPolicy = new DataSet("GradesAndPolicy");

			openConnection();

            // Select a table to hold one policy for a given course, add the table to data set. fill
            fillTableAndAddToDataSet(sqlPolicy + GlobalConstsVars.CID, "Policy", dsGradesAndPolicy);


			GlobalConstsVars.hwkCnt = System.Int16.Parse((dsGradesAndPolicy.Tables["Policy"].Rows[0]["NUMHWK"]).ToString());
			sqlVGrades = buildGradeSQLString(GlobalConstsVars.CID, GlobalConstsVars.hwkCnt);
            // Fill Grades table and add it to data set.
            fillTableAndAddToDataSet(sqlVGrades, "VGrades", dsGradesAndPolicy);
            dsGradesAndPolicy.Tables["VGrades"].PrimaryKey = new DataColumn[] { dsGradesAndPolicy.Tables["VGrades"].Columns["CID"],
                                                                                dsGradesAndPolicy.Tables["VGrades"].Columns["SID"] };
            // Create report table and add it to database
            fillTableAndAddToDataSet(sqlVClassReport + GlobalConstsVars.CID, "VClassReport", dsGradesAndPolicy);

			cnn.Close();
			return dsGradesAndPolicy;
		}
       
        public static System.Collections.Queue  getClassTrack(){
      
            string sql = "SELECT * FROM vClassTrack WHERE cid = " + GlobalConstsVars.CID + " ORDER BY Total Desc, LastName, FirstName";
            string line = null, strNull = "null";
            try
            {
                openConnection();
                cmd = new OracleCommand( sql, cnn);
                reader = cmd.ExecuteReader(System.Data.CommandBehavior.CloseConnection);
                System.Collections.Queue qTrack = new System.Collections.Queue(40) ;
                while (reader.HasRows && reader.Read())
                {
        
                    line = reader.GetValue(2).ToString().PadLeft(20) +                 // last name
                           ", " + reader.GetValue(3).ToString().PadRight(25).Substring(0, 20) +     // first name
                           "( " + reader.GetString(4).PadRight(8) + ")" +   // OS User name
                           " id=" + string.Format("{0:000000000}", reader.GetInt64(1)) +   // student ID
                           " major=" + (reader.IsDBNull(6) ? strNull.PadRight(20) :
                                        reader.GetString(6).PadRight(25).Substring(0, 20)) + // student major
                           " grade=" + reader.GetString(5).PadRight(3) +  // letter grade
                           " %=" + string.Format("{0:0.00}",reader.GetFloat(7));
                    qTrack.Enqueue ( line );
                    Console.WriteLine(line);
                }
                return qTrack;
            }
            catch (System.Exception e) { Console.WriteLine(e.StackTrace); return null; }
            finally
            {
                reader.Close();
                cmd.Dispose();
                cnn.Close();
            }
        }

		public static DataTable getStudents( string viewName ) 
		{
			try 
			{
				DataTable tb = new DataTable(viewName);
                //DataTable tb = new DataTable("STUDENTS");
                openConnection();
                adapter = new OracleDataAdapter("select * from " + viewName, cnn);
                //adapter = new OracleDataAdapter("SELECT * FROM students WHERE active = 'Y'", cnn);

				adapter.Fill(tb);
				return tb;
			} 
			catch ( System.Exception e ) { Console.WriteLine( e.StackTrace ); return null; }
			finally 
			{
				adapter.Dispose();
				cnn.Close();
			}
		}
		#endregion

		#region H. Wang - Updates Data Source (DB) throught Adapter.
		public static void saveGrade( DataSet ds ) 
		{
			openConnection();
			try 
			{

				adapter = new OracleDataAdapter(sqlVGrades, cnn);
                string colName;

				/* Build a update SQL statement based on the number of
				 * homework. You can call a stored procedure to update
				 * the database. However, the stored procedure is not as
				 * flexible as building dynamic update statement since the
				 * number of homework changes from time to time.
				 */

				/* ---------------------------------------------------
				 *  Build a UPDATE statement, Command and add it to
				 * the adpater.Updatestatement property.
				 -----------------------------------------------------*/
				string sqlUpdate = "UPDATE Grades set grade = :grade ";
				DataTable tb = ds.Tables["VGrades"];
                for (int i = 1; i < 5 + GlobalConstsVars.hwkCnt; i++)
                {
                    colName = tb.Columns[i + 6].ColumnName;
                    sqlUpdate += ", " + colName  + " = :"+ colName ;
                }
                sqlUpdate += " WHERE cid = :cid AND sid = :sid ";
				Console.WriteLine (sqlUpdate);
				OracleCommand cmd = new OracleCommand(sqlUpdate, cnn);
                OracleParameter param;
           
				param = cmd.Parameters.Add("Grade_New", OracleDbType.Varchar2, 2, "Grade");
				for ( int i = 1; i < 5 + GlobalConstsVars.hwkCnt - 1; i ++ ) 
				{
					colName = tb.Columns[i+6].ColumnName;
					param = cmd.Parameters.Add(colName+ "_New", OracleDbType.Decimal, 0, colName);
				}
            
                param = cmd.Parameters.Add("Comments_New", OracleDbType.Varchar2 , 1000, "Comments");
				param = cmd.Parameters.Add("Original_cid", OracleDbType.Int32  , 22, "cid");
                param.SourceVersion = DataRowVersion.Original;
                param = cmd.Parameters.Add("Original_sid", OracleDbType.Int32, 22, "sid");
                param.SourceVersion = DataRowVersion.Original;
				cmd.CommandTimeout = 10;

				adapter.UpdateCommand  = cmd;

				cmd = null;
				/* ---------------------------------------------------------
				 * Build a insertion command for data adapter.
				 * Tried to make the insertion call stored procedure
				 * AddStudentToClass. It fails. I have build a dynamic INSERT
				 * SQL statement.
				 * ---------------------------------------------------------*/
				string sqlInsert = "INSERT INTO Grades(cid, sid, grade, Comments",
					strValues = " VALUES(:cid, :sid, :grade, :comments";
				
				for ( int i = 1; i < 5 + GlobalConstsVars.hwkCnt - 1; i ++ ) 
				{
                    colName = tb.Columns[i+6].ColumnName ;
                    sqlInsert += ", " + colName;
                    strValues += ", :" + colName;
				}
				sqlInsert += ") " + strValues + ")";
				
				Console.WriteLine(sqlInsert);

				cmd = new OracleCommand(sqlInsert, cnn);
		
				param = cmd.Parameters.Add("cid_New", OracleDbType.Int32, 22, "cid");
				param = cmd.Parameters.Add("sid_New", OracleDbType.Int32, 22, "sid");
				param = cmd.Parameters.Add("grade_New", OracleDbType.Varchar2 , 2, "grade");
				param = cmd.Parameters.Add("grade_Comments", OracleDbType.Varchar2 , 1000, "Comments");
				for ( int i = 1; i < 5 + GlobalConstsVars.hwkCnt - 1; i ++ ) 
				{
					colName = tb.Columns[i+6].ColumnName;
					param = cmd.Parameters.Add(colName+ "_New", OracleDbType.Decimal, 0, colName);
				}
				cmd.CommandTimeout = 10;
				adapter.InsertCommand = cmd;
				cmd = null;
 
				/*----------------------------------------------------------------
				 * Buidl a SQL DELETE statement and put int adapter.DeleteCommand
				 * property.
				 * ---------------------------------------------------------------*/
				cmd = new OracleCommand("DELETE FROM Grades WHERE sid = :sid AND cid = :cid", cnn );
				param = cmd.Parameters.Add("Original_sid", OracleDbType.Int32, 22, "sid");
				param.SourceVersion = DataRowVersion.Default;
				param = cmd.Parameters.Add("Original_cid", OracleDbType.Int32, 22, "cid");
				param.SourceVersion = DataRowVersion.Default;
				cmd.CommandTimeout = 10;
				adapter.DeleteCommand = cmd;
				adapter.Update(ds.Tables["VGrades"].Select(null, null, System.Data.DataViewRowState.Deleted ));
				adapter.Update(ds.Tables["VGrades"].Select(null, null, System.Data.DataViewRowState.ModifiedOriginal ));
				adapter.Update(ds.Tables["VGrades"].Select(null, null, System.Data.DataViewRowState.Added));
			} 
			catch (System.Exception e) 
			{
				Console.WriteLine (e.StackTrace) ;}
			finally { cnn.Close(); adapter.Dispose(); }
		}

		public static void savePolicy( DataSet ds) 
		{
			openConnection();
			try 
			{
				/* The smiplest method of saving changes back to database.
				 * The method used OracleCommandBhuilder to build Update,
				 * Insert and Delete statement based on the Select statement.
				 * The automatically built three updating statements will be
				 * used to convert the row changes to corresponding SQL
				 * statements and save the changes back to database.
				 * The simple method can be used only if the select statement
				 *  is based on a single table and all primary key fields are
				 * included in the select clause.
				 */
				DataTable tb = ds.Tables["Policy"];

				//adapter = new OracleDataAdapter(sqlPolicy, cnn);

				string sqlUpdate = "UPDATE Policy set ";
                string colName = null;

                for (int i = 1; i < tb.Columns.Count; i++)
                {
                    colName = tb.Columns[i].ColumnName;
                    sqlUpdate += (i == 1 ? " " : ", ") + colName + " = :" + colName;
                }
                 
                sqlUpdate += " WHERE cid = :cid";
				Console.WriteLine (sqlUpdate);
				OracleCommand cmd = new OracleCommand(sqlUpdate, cnn);
				OracleParameter param;

               
				for ( int i = 1; i < tb.Columns.Count; i ++ ) 
				{
					colName = tb.Columns[i].ColumnName;
					param = cmd.Parameters.Add("NEW_" + colName, OracleDbType.Int16, 22, colName);
				}

				param = cmd.Parameters.Add("Original_CID", OracleDbType.Int32 , 22, "CID");
				param.SourceVersion = DataRowVersion.Original;

				adapter.UpdateCommand = cmd;
			
                adapter.Update(ds, "Policy");
			} 
			catch (System.Exception e) 
			{

                Console.WriteLine("error in adapter.Update(ds, \"Policy\")");
                Console.WriteLine(e.StackTrace);
            }
			finally { cnn.Close(); adapter.Dispose(); }
		}

		public static void saveStudent( DataTable dtStudent) 
		{
            string colName = null;
			string strSelectStu = "SELECT SID, lastName, firstName, active, OSUserName, MajorCode FROM students";
            string strInsertStu = "INSERT INTO students VALUES(:sid, :lastName, :firstName, :active, :osUserName, :majorCode )";
            string strUpdateStu = "UPDATE students SET lastName = :lastName, firstName = :firstName, Active = :active, OSUserName = : osUserName, MajorCode = :majorCode WHERE SID = :sid";
            OracleParameter param;
            try 
			{
				openConnection();
				adapter = new OracleDataAdapter(strSelectStu, cnn);

                cmd = new OracleCommand(strInsertStu, cnn);
				param = cmd.Parameters.Add("SID_NEW", OracleDbType.Int32, 22, "SID");
                for (int i = 1; i < dtStudent.Columns.Count - 1; i++)
                {
                    colName = dtStudent.Columns[i].ColumnName;
                    param = cmd.Parameters.Add(colName + "_NEW", OracleDbType.Varchar2, 0, colName );

                }
                param = cmd.Parameters.Add("MAJORCODE_NEW", OracleDbType.Int16, 22, "MAJORCODE");
                adapter.InsertCommand = cmd;

                cmd = new OracleCommand(strUpdateStu, cnn);

                // It seems like that the order number of parameter is determined by field order appeard in selec statemtn.
                for (int i = 1; i < dtStudent.Columns.Count - 1; i++)
                {
                    colName = dtStudent.Columns[i].ColumnName;
                    param = cmd.Parameters.Add(colName + "_NEW" , OracleDbType.Varchar2, 0, colName);
                }
                param = cmd.Parameters.Add("MAJORCODE_NEW", OracleDbType.Int16, 22, "MAJORCODE");
                param = cmd.Parameters.Add("Original_SID", OracleDbType.Int32, 22, "SID");
                //param.SourceVersion = DataRowVersion.Original;

                adapter.UpdateCommand = cmd;
				adapter.Update( dtStudent);
            } 
			catch (System.Exception e ) {
                Console.WriteLine("Error in Save Student records");
                Console.WriteLine(e.StackTrace); }

            finally 
			{
				adapter.Dispose();
				cmd.Dispose();
				cnn.Close();
			}
		}
		#endregion

		#region Insert/Delete/Update Data Source (DB) through Command objects.
		public static int removeStudentAndAllClasses( int sid, int instID )
		{
			try 
			{
				openConnection();
				cmd = new OracleCommand("DeleteStudent", cnn);
				cmd.CommandType = CommandType.StoredProcedure; 
				cmd.Parameters.Add("stuID", OracleDbType.Long , 9).Value = sid;
				cmd.Parameters.Add("InstID", OracleDbType.Long, 9).Value = instID;
				int cnt = cmd.ExecuteNonQuery();
				return cnt;
			} 
			catch (System.Exception e ) { Console.WriteLine( e.StackTrace) ; return 0;}
			finally { cmd.Dispose(); cnn.Close(); }
		}
		public static void culateTotal () // Calculates totals and rankings of a class.
		{
			try 
			{
				openConnection();
				OracleCommand cmd = new OracleCommand("CALTOTAL", cnn);
				cmd.CommandType = System.Data.CommandType.StoredProcedure;
				cmd.Parameters.Add("classID", OracleDbType.Long, 9).Value = GlobalConstsVars.CID;
				cmd.ExecuteNonQuery();
			} 
			catch (System.Exception e) { Console.WriteLine(e.StackTrace ); }
			finally { cnn.Close(); cmd.Dispose(); }
		}

		public static int  addNewClassAndPolicy( string cid, string yr, string quarter, string courseName, string section)
		{
			try 
			{
				openConnection();
				cmd = new OracleCommand("ADDCLASS", cnn);
				cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("CLASSID", OracleDbType.Long, 9).Value = int.Parse(cid);
                cmd.Parameters.Add("INStID", OracleDbType.Long, 9).Value = GlobalConstsVars.IID;
				cmd.Parameters.Add("YR", OracleDbType.Double, 0 ).Value = int.Parse(yr);
				cmd.Parameters.Add("QTR", OracleDbType.Varchar2 , 0 ).Value = quarter;
				cmd.Parameters.Add("CLASSNAME", OracleDbType.Varchar2 , 0 ).Value = courseName;
				cmd.Parameters.Add("SECTION", OracleDbType.Int16, 0 ).Value = int.Parse(section);
				int k = cmd.ExecuteNonQuery() ;
                GlobalConstsVars.CID = int.Parse(cid);
				return k;
			} 
			catch (System.Exception e ) { Console.WriteLine( e.StackTrace ); return -1; }
			finally { cnn.Close(); cmd.Dispose(); }
		}

		public static int removeClassAndPolicy( )
		{
			try 
			{
				openConnection();
				cmd = new OracleCommand("DELETECLASS", cnn);
				cmd.CommandType = CommandType.StoredProcedure;
				cmd.Parameters.Add("CLASSID", OracleDbType.Long, 9 ).Value = GlobalConstsVars.CID;
				cmd.Parameters.Add ("INSTID", OracleDbType.Long, 9 ).Value = GlobalConstsVars.IID ;
				int k = cmd.ExecuteNonQuery();
				return k;
			} catch ( System.Exception e ) { Console.WriteLine(e.StackTrace ); return -1; }
			finally { cnn.Close(); cmd.Dispose(); }
		}

		public static int changeStudentID( int oldID, int newID )
		{
			try 
			{
				openConnection();
				cmd = new OracleCommand("ChangeIDTo", cnn);
				cmd.CommandType = CommandType.StoredProcedure;
				cmd.Parameters.Add("oldID", OracleDbType.Double, 0 ).Value = oldID;
				cmd.Parameters.Add ("newID", OracleDbType.Double, 0 ).Value = newID;
				int k = cmd.ExecuteNonQuery();
				return k;
			} 
			catch (System.Exception e) { Console.WriteLine (e.StackTrace ); return -1;}
			finally { cnn.Close (); cmd.Dispose() ; }
		}

		#endregion
	} // end of class
}
